if(!window.FollowEditorIIDX22){
	FollowEditorIIDX22_setup();
}
with(FollowEditorIIDX22){

setData = function (){
	fe_Branch.setCharPref("data_version", data_version);
	fe_Branch.setCharPref("rival_list", unescape(encodeURIComponent(JSON.stringify(rival_list))));
	fe_Branch.setCharPref("userdata", unescape(encodeURIComponent(JSON.stringify(userdata))));

	return;
}

removeData = function (){
	fe_Branch.setCharPref("data_version", "0");
	fe_Branch.setCharPref("rival_list", "");
	fe_Branch.setCharPref("userdata", "");

	return;
}

getData = function (){
	var savedata_version = fe_Branch.getCharPref("data_version");
	if(savedata_version != data_version){
		if(savedataCheck(savedata_version)){
			return 1;
		}
	}

	rival_list = JSON.parse(decodeURIComponent(escape(fe_Branch.getCharPref("rival_list"))));
	userdata = JSON.parse(decodeURIComponent(escape(fe_Branch.getCharPref("userdata"))));

	if(savedata_version != data_version){
		if(savedataConvert(savedata_version)){
			return 1;
		}
	}

	return 0;
}

matchWordLine = function (res, word, offset){
	try{
		if(offset==undefined){
			offset = 0;
		}
		var re = RegExp(word);
		var tmp = -1;
		for(var i=offset; i<res.length; i++){
			if(res[i].match(re)){
				tmp = i;
				break;
			}
		}

		return tmp;
	}catch(e){
		return -1;
	}
}

iidx_id_Check = function (id){
	if(id.match(/^[0-9]{4}-[0-9]{4}$/)){
		return 0;
	}
	return -1;
}

setupWindow = function (){
	//保存済みデータの読み込み
	try{
		var tmp = getData();
		if(tmp == 1){
			rival_list = new Array();
		}
	}catch(e){
		rival_list = new Array();
	}
	viewList();

	mainTab.contentDocument.getElementById("readAC").addEventListener("click", (function(){
		return function(){
			var req = new XMLHttpRequest();
			req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_follow.html' , true);
			req.onreadystatechange = function (aEvt){
				if(req.readyState == 4){
					if(req.status == 200){
						var res = req.responseText.split(">");
						if(matchWordLine(res, "ログインが必要です") == -1){
							if(confirm('公式サイトからデータを読み込みますか？\n終了までに時間がかかる場合があります。')){
								readList();
							}
						}else{
							alert("公式サイトへの接続に失敗しました。\nログインしていない可能性があります。");
						}
					}
				}
			};
			req.send(null);
			return;
		}
	})(), false);
	mainTab.contentDocument.getElementById("readHash").addEventListener("click", (function(){
		return function(){
			if(confirm('公式サイトからデータを読み込みますか？\n終了までに時間がかかる場合があります。')){
				var tmp = 0;
				for(var i=0; i<rival_list.length; i++){
					if(!((rival_list[i].follow)||(rival_list[i].follower)||(rival_list[i].rivalsp)||(rival_list[i].rivaldp)||(rival_list[i].rev_rivalsp)||(rival_list[i].rev_rivaldp))){
						tmp++;
					}
				}
				readHash(rival_list.length-1, tmp, tmp);
			}
			return;
		}
	})(), false);
	mainTab.contentDocument.getElementById("removeGM").addEventListener("click", (function(){
		return function(){
			if(confirm('保存してあるデータを削除しますか？\n終了までに時間がかかる場合があります。')){
				removeData();
				rival_list = new Array();
				viewList();
			}
		}
	})(), false);
	mainTab.contentDocument.getElementById("readIIDX19").addEventListener("click", (function(){
		return function(){
			var obj = new Object();
			obj.follow = mainTab.contentDocument.getElementById('IIDX19-follow').checked;
			obj.rival_sv = mainTab.contentDocument.getElementById('IIDX19-rival-sv').checked;
			obj.memo = mainTab.contentDocument.getElementById('IIDX19-memo').checked;
			obj.version = 19;
			readPrevVersion(obj);
		}
	})(), false);
	mainTab.contentDocument.getElementById("readIIDX20").addEventListener("click", (function(){
		return function(){
			var obj = new Object();
			obj.follow = mainTab.contentDocument.getElementById('IIDX20-follow').checked;
			obj.rival_sv = mainTab.contentDocument.getElementById('IIDX20-rival-sv').checked;
			obj.memo = mainTab.contentDocument.getElementById('IIDX20-memo').checked;
			obj.version = 20;
			readPrevVersion(obj);
		}
	})(), false);
	mainTab.contentDocument.getElementById("readIIDX21").addEventListener("click", (function(){
		return function(){
			var obj = new Object();
			obj.follow = mainTab.contentDocument.getElementById('IIDX21-follow').checked;
			obj.rival_sv = mainTab.contentDocument.getElementById('IIDX21-rival-sv').checked;
			obj.memo = mainTab.contentDocument.getElementById('IIDX21-memo').checked;
			obj.version = 21;
			readPrevVersion(obj);
		}
	})(), false);
	mainTab.contentDocument.getElementById("readTextMemo").addEventListener("click", (function(){
		return function(){
			readText(false);
		}
	})(), false);
	mainTab.contentDocument.getElementById("readTextAll").addEventListener("click", (function(){
		return function(){
			readText(true);
		}
	})(), false);
	mainTab.contentDocument.getElementById("writeText").addEventListener("click", (function(){
		return function(){
			writeText();
		}
	})(), false);
	mainTab.contentDocument.getElementById("readIIDXID").addEventListener("click", (function(){
		return function(){
			var id = mainTab.contentDocument.getElementById("iidxid").value;
			readIIDXID(id);
		}
	})(), false);
	mainTab.contentDocument.getElementById("sort_cat").addEventListener("change", (function(){
		return function(){
			viewList();
		}
	})(), false);
	mainTab.contentDocument.getElementById("sort_order").addEventListener("change", (function(){
		return function(){
			viewList();
		}
	})(), false);
	mainTab.contentDocument.getElementById("readStatusAll").addEventListener("click", (function(){
		return function(){
			if(confirm('リストの全ユーザーのステータスを公式サイトから読み込みますか？\n終了までに時間がかかる場合があります。')){
				readStatus(0, rival_list.length-1, rival_list.length, rival_list.length);
			}
		}
	})(), false);
	mainTab.contentDocument.getElementById("readStatusNew").addEventListener("click", (function(){
		return function(){
			if(confirm('リスト中のステータスを取得していないユーザーのステータスを公式サイトから読み込みますか？\n終了までに時間がかかる場合があります。')){
				var tmp = 0;
				for(var i=0; i<rival_list.length; i++){
					deleteErrorStatus(i);
					if(!((typeof rival_list[i].danisp != "undefined")&&(typeof rival_list[i].danidp != "undefined")&&(typeof rival_list[i].djpsp != "undefined")&&(typeof rival_list[i].djpdp != "undefined")&&(typeof rival_list[i].comment != "undefined")&&(typeof rival_list[i].area != "undefined"))){
						tmp++;
					}
				}
				readStatus(1, rival_list.length-1, tmp, tmp);
			}
		}
	})(), false);
	//フォローコース
	mainTab.contentDocument.getElementById("readCourseAll").addEventListener("click", (function(){
		return function(){
			if(confirm('ユーザーコース設定状態を公式サイトから読み込みますか？\n終了までに時間がかかる場合があります。')){
				readCourse();
			}
		}
	})(), false);
	mainTab.contentDocument.getElementById("readCourseIDNew").addEventListener("click", (function(){
		return function(){
			if(confirm('リスト中のIDを取得していないユーザーのIDを公式サイトから読み込みますか？\n終了までに時間がかかる場合があります。')){
				var tmp = 0;
				for(var i=0; i<rival_list.length; i++){
					if(typeof rival_list[i].course_id == "undefined"){
						tmp++;
					}
				}
				readCourseID(0, rival_list.length-1, tmp, tmp);
			}
		}
	})(), false);
	mainTab.contentDocument.getElementById("readCourseIDAll").addEventListener("click", (function(){
		return function(){
			if(confirm('リスト中の全ユーザーのIDを公式サイトから読み込みますか？\n終了までに時間がかかる場合があります。')){
				readCourseID(1, rival_list.length-1, rival_list.length, rival_list.length);
			}
		}
	})(), false);
	return;
}

trim = function (str){
	if(typeof str === 'undefined'){
		return str;
	}else{
		var tmp = str.replace(/^\s+|\s+$/g, "");
		return tmp;
	}
}

readFollowList = function(offset){
	mainTab.contentDocument.getElementById('data').innerHTML = "フォローリストを読み込み中です。";
	var req = new XMLHttpRequest();
	req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_follow.html?offset=' + offset , true);
	req.onreadystatechange = function (aEvt){
		if(req.readyState == 4){
			if(req.status == 200){
				try{
					var res = req.responseText.split(">");

					if(matchWordLine(res, "マイページ") != -1){
						if(matchWordLine(res, "存在しません") == -1){
							if(offset == 0){
								for(var i=0; i<rival_list.length; i++){
									rival_list[i].follow = false;
								}
							}
							var tmp = matchWordLine(res, "page_title_rival_follow.jpg");
							tmp = matchWordLine(res, "table", tmp);
							while((tmp = matchWordLine(res, "data_another.html", (tmp+1))) != -1){
								var tmp_rival = new Object();
								tmp_rival.hash = res[tmp].split("=")[2].split("\"")[0];
								tmp_rival.djname = trim(res[tmp+1].split("<")[0]);
								tmp_rival.iidxid = trim(res[tmp+6].split("<")[0]);
								tmp_rival.follow = true;
								tmp_rival.follower = false;
								tmp_rival.rivalsp = false;
								tmp_rival.rivaldp = false;
								tmp_rival.rev_rivalsp = false;
								tmp_rival.rev_rivaldp = false;
								for(var i=0;i<rival_list.length;i++){
									if(rival_list[i].iidxid == tmp_rival.iidxid){
										break;
									}
								}
								if(i == rival_list.length){
									rival_list.push(tmp_rival);
								}else{
									rival_list[i].hash = tmp_rival.hash;
									rival_list[i].djname = tmp_rival.djname;
									rival_list[i].follow = true;
								}
							}
							readFollowList(offset + 20);
						}else{
							readFollowerList(0);
						}
					}else{
						viewList();
						alert("フォローリストの読み込みに失敗しました。\nログインしていない可能性があります。");
					}
				}catch(e){
					viewList();
					alert("フォローリストの読み込みに失敗しました。\n" + e);
				}
			}
		}
	};
	req.send(null);
	return;
}

readFollowerList = function(offset){
	mainTab.contentDocument.getElementById('data').innerHTML = "フォロワーリストを読み込み中です。";
	var req = new XMLHttpRequest();
	req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_follower.html?offset=' + offset , true);
	req.onreadystatechange = function (aEvt){
		if(req.readyState == 4){
			if(req.status == 200){
				try{
					var res = req.responseText.split(">");

					if((matchWordLine(res, "存在しません") == -1)&&(matchWordLine(res, "ログインボタンを押してください") == -1)){
						if(offset == 0){
							for(var i=0; i<rival_list.length; i++){
								rival_list[i].follower = false;
							}
						}
						var tmp = matchWordLine(res, "table");
						while((tmp = matchWordLine(res, "data_another.html", (tmp+1))) != -1){
							var tmp_rival = new Object();
							tmp_rival.hash = res[tmp].split("=")[2].split("\"")[0];
							tmp_rival.djname = trim(res[tmp+1].split("<")[0]);
							tmp_rival.iidxid = trim(res[tmp+4].split("<")[0]);
							tmp_rival.follow = false;
							tmp_rival.follower = true;
							tmp_rival.rivalsp = false;
							tmp_rival.rivaldp = false;
							tmp_rival.rev_rivalsp = false;
							tmp_rival.rev_rivaldp = false;
							for(var i=0;i<rival_list.length;i++){
								if(rival_list[i].iidxid == tmp_rival.iidxid){
									break;
								}
							}
							if(i == rival_list.length){
								rival_list.push(tmp_rival);
							}else{
								rival_list[i].hash = tmp_rival.hash;
								rival_list[i].djname = tmp_rival.djname;
								rival_list[i].follower = true;
							}
						}
						readFollowerList(offset + 20);
					}else{
						readRivalList();
					}
				}catch(e){
					viewList();
					alert("フォロワーリストの読み込みに失敗しました。\n" + e);
				}
			}
		}
	};
	req.send(null);
	return;
}

readRivalList = function(){
	mainTab.contentDocument.getElementById('data').innerHTML = "ライバルリストを読み込み中です。";
	var req = new XMLHttpRequest();
	req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_list.html', true);
	req.onreadystatechange = function (aEvt){
		if(req.readyState == 4){
			if(req.status == 200){
				try{
					var res = req.responseText.split(">");

					if(matchWordLine(res, "マイページ") != -1){
						if(matchWordLine(res, "加入が必要です") == -1){
							for(var i=0; i<rival_list.length; i++){
								rival_list[i].rivalsp = false;
								rival_list[i].rivaldp = false;
							}
							if(matchWordLine(res, "データがみつかりません。") == -1){
								var tmp = matchWordLine(res, "table");
								if(tmp != -1){
									tmp = matchWordLine(res, "SP</th", tmp);
									for(var num=0; num<5; num++){
										tmp = matchWordLine(res, "data_another.html", (tmp+1));
										var tmp_rival = new Object();
										tmp_rival.hash = res[tmp].split("=")[2].split("\"")[0];
										if(tmp_rival.hash == ""){
											continue;
										}
										tmp_rival.djname = trim(res[tmp+1].split("<")[0]);
										tmp_rival.iidxid = trim(res[tmp+4].split("<")[0]);
										tmp_rival.danisp = daniStrToNum(trim(res[tmp+6].split("<")[0].split("/")[0]));
										tmp_rival.danidp = daniStrToNum(trim(res[tmp+6].split("<")[0].split("/")[1]));
										tmp_rival.follow = false;
										tmp_rival.follower = false;
										tmp_rival.rivalsp = true;
										tmp_rival.rivaldp = false;
										tmp_rival.rev_rivalsp = false;
										tmp_rival.rev_rivaldp = false;
										for(var i=0;i<rival_list.length;i++){
											if(rival_list[i].iidxid == tmp_rival.iidxid){
												break;
											}
										}
										if(i == rival_list.length){
											rival_list.push(tmp_rival);
										}else{
											rival_list[i].hash = tmp_rival.hash;
											rival_list[i].djname = tmp_rival.djname;
											rival_list[i].danisp = tmp_rival.danisp;
											rival_list[i].danidp = tmp_rival.danidp;
											rival_list[i].rivalsp = true;
										}
									}
								}

								tmp = matchWordLine(res, "table", tmp);
								if(tmp != -1){
									tmp = matchWordLine(res, "DP</th", tmp);
									for(var num=0; num<5; num++){
										tmp = matchWordLine(res, "data_another.html", (tmp+1));
										var tmp_rival = new Object();
										tmp_rival.hash = res[tmp].split("=")[2].split("\"")[0];
										if(tmp_rival.hash == ""){
											continue;
										}
										tmp_rival.djname = trim(res[tmp+1].split("<")[0]);
										tmp_rival.iidxid = trim(res[tmp+4].split("<")[0]);
										tmp_rival.danisp = daniStrToNum(trim(res[tmp+6].split("<")[0].split("/")[0]));
										tmp_rival.danidp = daniStrToNum(trim(res[tmp+6].split("<")[0].split("/")[1]));
										tmp_rival.follow = false;
										tmp_rival.follower = false;
										tmp_rival.rivalsp = false;
										tmp_rival.rivaldp = true;
										tmp_rival.rev_rivalsp = false;
										tmp_rival.rev_rivaldp = false;
										for(var i=0;i<rival_list.length;i++){
											if(rival_list[i].iidxid == tmp_rival.iidxid){
												break;
											}
										}
										if(i == rival_list.length){
											rival_list.push(tmp_rival);
										}else{
											rival_list[i].hash = tmp_rival.hash;
											rival_list[i].djname = tmp_rival.djname;
											rival_list[i].danisp = tmp_rival.danisp;
											rival_list[i].danidp = tmp_rival.danidp;
											rival_list[i].rivaldp = true;
										}
									}
								}
							}
							readRevRivalList();
						}else{
							viewList();
							alert("ライバルリストの読み込みに失敗しました。\ne-amusement GATE利用権があるか確認してください。");
						}
					}else{
						viewList();
						alert("ライバルリストの読み込みに失敗しました。\nログインしていない可能性があります。");
					}

				}catch(e){
					viewList();
					alert("ライバルリストの読み込みに失敗しました。\n" + e);
				}
			}
		}
	};
	req.send(null);
	return;
}

readRevRivalList = function(){
	mainTab.contentDocument.getElementById('data').innerHTML = "逆ライバルリストを読み込み中です。";
	var req = new XMLHttpRequest();
	req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival2.html' , true);
	req.onreadystatechange = function (aEvt){
		if(req.readyState == 4){
			if(req.status == 200){
				try{
					var res = req.responseText.split(">");

					if((matchWordLine(res, "加入が必要です") == -1)&&(matchWordLine(res, "存在しません") == -1)&&(matchWordLine(res, "ログインボタンを押してください") == -1)){
						for(var i=0; i<rival_list.length; i++){
							rival_list[i].rev_rivalsp = false;
							rival_list[i].rev_rivaldp = false;
						}
						var tmp = matchWordLine(res, "table");
						while((tmp = matchWordLine(res, "data_another.html", (tmp+1))) != -1){
							var tmp_rival = new Object();
							tmp_rival.hash = res[tmp].split("=")[2].split("\"")[0];
							tmp_rival.djname = trim(res[tmp+1].split("<")[0].split("(")[0]);
							var style_txt = trim(res[tmp+1].split("<")[0]);
							tmp_rival.iidxid = trim(res[tmp+4].split("<")[0]);
							tmp_rival.danisp = daniStrToNum(trim(res[tmp+6].split("<")[0].split("/")[0]));
							tmp_rival.danidp = daniStrToNum(trim(res[tmp+6].split("<")[0].split("/")[1]));
							tmp_rival.area = trim(res[tmp+8].split("<")[0]);
							tmp_rival.follow = false;
							tmp_rival.follower = false;
							tmp_rival.rivalsp = false;
							tmp_rival.rivaldp = false;
							if(style_txt.search('(SP)') != -1){
								tmp_rival.rev_rivalsp = true;
							}else{
								tmp_rival.rev_rivalsp = false;
							}
							if(style_txt.search('(DP)') != -1){
								tmp_rival.rev_rivaldp = true;
							}else{
								tmp_rival.rev_rivaldp = false;
							}
							for(var i=0;i<rival_list.length;i++){
								if(rival_list[i].iidxid == tmp_rival.iidxid){
									break;
								}
							}
							if(i == rival_list.length){
								rival_list.push(tmp_rival);
							}else{
								rival_list[i].hash = tmp_rival.hash;
								rival_list[i].djname = tmp_rival.djname;
								rival_list[i].danisp = tmp_rival.danisp;
								rival_list[i].danidp = tmp_rival.danidp;
								rival_list[i].area = tmp_rival.area;
								if(style_txt.search('(SP)') != -1){
									rival_list[i].rev_rivalsp = true;
								}else{
									rival_list[i].rev_rivalsp = false;
								}
								if(style_txt.search('(DP)') != -1){
									rival_list[i].rev_rivaldp = true;
								}else{
									rival_list[i].rev_rivaldp = false;
								}
							}
						}
					}

					viewList();
					alert("読み込みが完了しました。");
				}catch(e){
					viewList();
					alert("逆ライバルリストの読み込みに失敗しました。\n" + e);
				}
			}
		}
	};
	req.send(null);
	return;
}

sortList = function(){
	var cat = mainTab.contentDocument.getElementById('sort_cat').value;
	var order = mainTab.contentDocument.getElementById('sort_order').value;

	var rlist = new Array();
	for(var i=0;i<rival_list.length; i++){
		rlist.push(i);
	}

	var cat_name = new Array("", "djname", "iidxid", "follow", "follower", "rivalsp", "rivaldp", "rev_rival", "danisp", "djpsp", "danidp", "djpdp");

	if(cat != 0){
		for(var i=0; i<rlist.length; i++){
			for(var j=i+1; j<rlist.length; j++){
				if(rival_list[rlist[i]][cat_name[cat]] > rival_list[rlist[j]][cat_name[cat]]){
					var tmp = rlist[i];
					rlist[i] = rlist[j];
					rlist[j] = tmp;
				}
			}
		}
	}
	if(order == 1){
		rlist.reverse();
	}

	return rlist;
}

viewList = function(){
	try{
		var sv_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var sv_Branch = sv_prefs.getBranch("extensions.ScoreViewerForIIDX22.");
		var rival_data_sv = JSON.parse(sv_Branch.getCharPref("rival_data"));
		var flag_sv = true;
	}catch(e){
		var flag_sv = false;
	}

	rlist = sortList();

	var txt = "";
	txt += "<table border=\"1\">\n";
	txt += "<tr align=\"center\">\n";
	if(fe_Branch.getBoolPref("view_number")){ txt += "<td>No.</td>\n"; }
	if(fe_Branch.getBoolPref("view_djname")){ txt += "<td>DJ NAME</td>\n"; }
	if(fe_Branch.getBoolPref("view_iidxid")){ txt += "<td>IIDX ID</td>\n"; }
	if(fe_Branch.getBoolPref("view_danisp")){ txt += "<td>SP段位</td>\n"; }
	if(fe_Branch.getBoolPref("view_djpsp")){ txt += "<td>SP DJP</td>\n"; }
	if(fe_Branch.getBoolPref("view_danidp")){ txt += "<td>DP段位</td>\n"; }
	if(fe_Branch.getBoolPref("view_djpdp")){ txt += "<td>DP DJP</td>\n"; }
	if(fe_Branch.getBoolPref("view_area")){ txt += "<td>エリア</td>\n"; }
	if(fe_Branch.getBoolPref("view_shop")){ txt += "<td>所属店舗</td>\n"; }
	if(fe_Branch.getBoolPref("view_follow")){ txt += "<td colspan=\"2\">フォロー</td>\n"; }
	if(fe_Branch.getBoolPref("view_follower")){ txt += "<td>フォロワー</td>\n"; }
	if(fe_Branch.getBoolPref("view_rivalsp")){ txt += "<td colspan=\"2\">SPライバル</td>\n"; }
	if(fe_Branch.getBoolPref("view_rivaldp")){ txt += "<td colspan=\"2\">DPライバル</td>\n"; }
	if(fe_Branch.getBoolPref("view_rev_rivalsp")){ txt += "<td>SP逆ライバル</td>\n"; }
	if(fe_Branch.getBoolPref("view_rev_rivaldp")){ txt += "<td>DP逆ライバル</td>\n"; }
	if(fe_Branch.getBoolPref("view_course")){ txt += '<td colspan="2">フォローコース</td>\n'; }
	if(fe_Branch.getBoolPref("view_comment")){ txt += "<td>コメント</td>\n"; }
	if(fe_Branch.getBoolPref("view_memo")){ txt += "<td colspan=\"2\">メモ</td>\n"; }
	if((fe_Branch.getBoolPref("view_scoreviewer"))&&(flag_sv)){
		txt += "<td colspan=\"2\">ScoreViewerライバル</td>\n";
	}
	if(fe_Branch.getBoolPref("view_delete")){ txt += "<td>削除</td>\n"; }
	txt += "</tr>\n";
	var tmp_cl = 0;
	var class_array = new Array("odd", "even");
	for(var i=0; i<rival_list.length; i++){
		txt += "<tr class=\"" + class_array[tmp_cl] + "\">\n";
		if(fe_Branch.getBoolPref("view_number")){
			txt += "<td align=\"right\">" + (i+1) + "</td>\n";
		}
		if(fe_Branch.getBoolPref("view_djname")){
			if(typeof rival_list[rlist[i]].djname != "undefined"){
				if(rival_list[rlist[i]].hash == 'no-exist'){
					txt += "<td class=\"none\">" + rival_list[rlist[i]].djname + "</td>\n";
				}else{
					txt += "<td><a href=\"http://p.eagate.573.jp/game/2dx/22/p/djdata/data_another.html?rival=" + rival_list[rlist[i]].hash + "\" target=\"_blank\">" + rival_list[rlist[i]].djname + "</a></td>\n";
				}
			}else{
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}
		}
		if(fe_Branch.getBoolPref("view_iidxid")){
			txt += "<td>" + rival_list[rlist[i]].iidxid + "</td>\n";
		}
		if(fe_Branch.getBoolPref("view_danisp")){
			if(typeof rival_list[rlist[i]].danisp == "undefined"){
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}else if(rival_list[rlist[i]].danisp == -1){
				txt += "<td class=\"none\" align=\"center\">" + daniNumToStr(rival_list[rlist[i]].danisp) + "</td>\n";
			}else{
				txt += "<td align=\"center\">" + daniNumToStr(rival_list[rlist[i]].danisp) + "</td>\n";
			}
		}
		if(fe_Branch.getBoolPref("view_djpsp")){
			if(typeof rival_list[rlist[i]].djpsp == "undefined"){
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}else if((isNaN(rival_list[rlist[i]].djpsp))||(rival_list[rlist[i]].djpsp == null)){
				txt += "<td class=\"none\" align=\"right\">- pt.</td>\n";
			}else{
				txt += "<td align=\"right\">" + rival_list[rlist[i]].djpsp + " pt.</td>\n";
			}
		}
		if(fe_Branch.getBoolPref("view_danidp")){
			if(typeof rival_list[rlist[i]].danidp == "undefined"){
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}else if(rival_list[rlist[i]].danidp == -1){
				txt += "<td class=\"none\" align=\"center\">" + daniNumToStr(rival_list[rlist[i]].danidp) + "</td>\n";
			}else{
				txt += "<td align=\"center\">" + daniNumToStr(rival_list[rlist[i]].danidp) + "</td>\n";
			}
		}
		if(fe_Branch.getBoolPref("view_djpdp")){
			if(typeof rival_list[rlist[i]].djpdp == "undefined"){
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}else if((isNaN(rival_list[rlist[i]].djpdp))||(rival_list[rlist[i]].djpsp == null)){
				txt += "<td class=\"none\" align=\"right\">- pt.</td>\n";
			}else{
				txt += "<td align=\"right\">" + rival_list[rlist[i]].djpdp + " pt.</td>\n";
			}
		}
		//エリア
		if(fe_Branch.getBoolPref("view_area")){
			if((typeof rival_list[rlist[i]].area != "undefined")&&(rival_list[rlist[i]].area != "")){
				txt += "<td align=\"center\">" + rival_list[rlist[i]].area + "</td>\n";
			}else{
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}
		}
		//所属店舗
		if(fe_Branch.getBoolPref("view_shop")){
			if((typeof rival_list[rlist[i]].shop != "undefined")&&(rival_list[rlist[i]].shop != "")){
				txt += "<td align=\"center\">" + rival_list[rlist[i]].shop + "</td>\n";
			}else{
				if(rival_list[rlist[i]].shop == "未登録"){
					txt += "<td class=\"none\" align=\"center\">" + rival_list[rlist[i]].shop + "</td>\n";
				}else{
					txt += "<td class=\"none\" align=\"center\">-</td>\n";
				}
			}
		}
		var cat = new Array("follow", "follower", "rivalsp", "rivaldp", "rev_rivalsp", "rev_rivaldp");
		for(var j=0; j<cat.length; j++){
			if(fe_Branch.getBoolPref("view_" + [cat[j]])){
				var tmp = "";
				if(rival_list[rlist[i]][cat[j]]){
					tmp = " class=\"true\"";
					txt += "<td align=\"center\"" + tmp + ">○</td>\n";
				}else{
					txt += "<td align=\"center\">×</td>\n";
				}
				if((cat[j]=="follow")||(cat[j]=="rivalsp")||(cat[j]=="rivaldp")){
					txt += "<td align=\"center\"" + tmp + "><input type=\"button\" id=\"change_" + rlist[i] + "_" + cat[j] + "\" value=\"切替\"></td>";
				}
			}
		}
		//フォローコース
		if(fe_Branch.getBoolPref("view_course")){
			if(typeof rival_list[rlist[i]].course_id != "undefined"){
				var tmp = "";
				if(rival_list[rlist[i]].course_active){
					tmp = ' class="true"';
					txt += '<td align="center"' + tmp + '><a href="http://p.eagate.573.jp/game/2dx/22/p/originalcourse/courseinfo.html?course_type=' + rival_list[rlist[i]].course_id + '" target="_blank">○</a></td>\n';
				}else{
					txt += '<td align="center"><a href="http://p.eagate.573.jp/game/2dx/22/p/originalcourse/courseinfo.html?course_type=' + rival_list[rlist[i]].course_id + '" target="_blank">×</a></td>\n';
				}
				txt += '<td align="center"' + tmp + '><input type="button" id="change_' + rlist[i] + '_course" value="切替"></td>';
			}else{
				txt += '<td class="none" align="center" colspan="2">ID未取得</td>\n';
			}
		}
		//コメント
		if(fe_Branch.getBoolPref("view_comment")){
			if(typeof rival_list[rlist[i]].comment != "undefined"){
				txt += "<td align=\"left\">" + rival_list[rlist[i]].comment + "</td>\n";
			}else{
				txt += "<td class=\"none\" align=\"center\">-</td>\n";
			}
		}
		//memo
		if(fe_Branch.getBoolPref("view_memo")){
			if((typeof rival_list[rlist[i]].memo != "undefined")&&(rival_list[rlist[i]].memo != "")){
				txt += "<td align=\"center\"><input type=\"button\" id=\"change_" + rlist[i] + "_memo" + "\" value=\"変更\"></td>";
				txt += "<td align=\"left\">" + rival_list[rlist[i]].memo + "</td>\n";
			}else{
				txt += "<td align=\"center\" class=\"none\"><input type=\"button\" id=\"change_" + rlist[i] + "_memo" + "\" value=\"変更\"></td>";
				txt += "<td align=\"left\" class=\"none\"></td>\n";
			}
		}
		if((fe_Branch.getBoolPref("view_scoreviewer"))&&(flag_sv)){
			for(var j=0; j<rival_data_sv.length; j++){
				if(rival_data_sv[j].id == rival_list[rlist[i]].iidxid){
					break;
				}
			}
			var tmp = "";
			if(j==rival_data_sv.length){
				txt += "<td align=\"center\">×</td>\n";
			}else{
				tmp = " class=\"true\"";
				txt += "<td align=\"center\"" + tmp + ">○</td>\n";
			}
			txt += "<td align=\"center\"" + tmp + "><input type=\"button\" id=\"change_" + rlist[i] + "_sv" + "\" value=\"切替\"></td>";
		}
		if(fe_Branch.getBoolPref("view_delete")){
			txt += "<td align=\"center\"><input type=\"button\" id=\"del_" + rlist[i] + "\" value=\"削除\"></td>";
		}
		txt += "</tr>\n";

		if(tmp_cl==0){
			tmp_cl = 1;
		}else{
			tmp_cl = 0;
		}
	}
	txt += "</table>\n";
	mainTab.contentDocument.getElementById('data').innerHTML = txt;

	setData();
	addEvent();

	return;
}

addEvent = function(){
	for(var i=0; i<rival_list.length; i++){
		try{
			mainTab.contentDocument.getElementById("change_" + i + "_follow").addEventListener("click", (function(j){
				return function(){
					changeFollow(j);
				}
			})(i), false);
		}catch(e){}
	}
	for(var i=0; i<rival_list.length; i++){
		try{
			mainTab.contentDocument.getElementById("change_" + i + "_rivalsp").addEventListener("click", (function(j){
				return function(){
					changeRivalSP(j);
				}
			})(i), false);
		}catch(e){}
	}
	for(var i=0; i<rival_list.length; i++){
		try{
			mainTab.contentDocument.getElementById("change_" + i + "_rivaldp").addEventListener("click", (function(j){
				return function(){
					changeRivalDP(j);
				}
			})(i), false);
		}catch(e){}
	}
	for(var i=0; i<rival_list.length; i++){
		try{
			if(typeof rival_list[i].course_id != "undefined"){
				mainTab.contentDocument.getElementById("change_" + i + "_course").addEventListener("click", (function(j){
					return function(){
						changeCourse(j);
					}
				})(i), false);
			}
		}catch(e){}
	}
	for(var i=0; i<rival_list.length; i++){
		try{
			mainTab.contentDocument.getElementById("change_" + i + "_memo").addEventListener("click", (function(j){
				return function(){
					changeMemo(j);
				}
			})(i), false);
		}catch(e){}
	}
	for(var i=0; i<rival_list.length; i++){
		try{
			mainTab.contentDocument.getElementById("del_" + i).addEventListener("click", (function(j){
				return function(){
					if(confirm("リストから" + rival_list[j].djname + "[" + rival_list[j].iidxid + "]を削除しますか？")){
						rival_list = rival_list.slice(0,j).concat(rival_list.slice(j+1));
						viewList();
					}
				}
			})(i), false);
		}catch(e){}
	}
	try{
		var sv22_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var sv22_Branch = sv22_prefs.getBranch("extensions.ScoreViewerForIIDX22.");
		var rival_data_sv = JSON.parse(sv22_Branch.getCharPref("rival_data"));
		var flag_sv = true;
	}catch(e){
		var flag_sv = false;
	}
	if(flag_sv){
		for(var i=0; i<rival_list.length; i++){
			try{
				mainTab.contentDocument.getElementById("change_" + i + "_sv").addEventListener("click", (function(j){
					return function(){
						changeRivalScoreViewer(j);
						viewList();
					}
				})(i), false);
			}catch(e){}
		}
	}

	return;
}

changeRivalScoreViewer = function(num){
	try{
		var sv_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		var sv_Branch = sv_prefs.getBranch("extensions.ScoreViewerForIIDX22.");
		var rival_data_sv = JSON.parse(sv_Branch.getCharPref("rival_data"));
		for(var i=0; i<rival_data_sv.length; i++){
			if(rival_data_sv[i].id == rival_list[num].iidxid){
				break;
			}
		}
		if(i==rival_data_sv.length){
			var tmp = new Object();
			tmp.name = rival_list[num].djname;
			tmp.id = rival_list[num].iidxid;
			tmp.hash = rival_list[num].hash;
			rival_data_sv.push(tmp);
		}else{
			rival_data_sv.splice(i,1);
		}
		sv_Branch.setCharPref("rival_data", JSON.stringify(rival_data_sv));
	}catch(e){
		alert("Score Viewerのライバル変更に失敗しました。");
	}
	return;
}

changeFollow = function(num){
	function follow(){
		var req = new XMLHttpRequest();
		req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_register.html?rival=' + rival_list[num].hash + '&regist=1&cmp=1' , true);
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "フォロー登録しました") == -1){
							alert("フォローの登録に失敗しました。");
						}else{
							rival_list[num].follow = true;
							viewList();
						}
					}catch(e){
						alert("フォローの登録に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	function unfollow(){
		var req = new XMLHttpRequest();
		req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_register.html?rival=' + rival_list[num].hash + '&delete=1&cmp=1' , true);
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "フォロー解除しました") == -1){
							alert("フォローの解除に失敗しました。");
						}else{
							rival_list[num].follow = false;
							viewList();
						}
					}catch(e){
						alert("フォローの解除に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	if(rival_list[num].follow){
		unfollow();
	}else{
		follow();
	}
}

changeRivalSP = function(num){
	function regist(){
		var req = new XMLHttpRequest();
		req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_active.html?saflg=1&send=send&rival=' + rival_list[num].hash , true);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "設定を更新しました") == -1){
							var total = 0;
							for(var i=0; i<rival_list.length; i++){
								if(rival_list[i].rivalsp){
									total++;
								}
							}
							if(total<5){
								alert("ライバルの登録に失敗しました。");
							}else{
								alert("ライバルの登録に失敗しました。\nSPライバルが既に5件設定されている可能性があります。");
							}
						}else{
							rival_list[num].rivalsp = true;
							viewList();
						}
					}catch(e){
						alert("ライバルの登録に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	function unregist(){
		var req = new XMLHttpRequest();
		req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_active.html?saflg=2&send=send&rival=' + rival_list[num].hash , true);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "設定を更新しました") == -1){
							alert("ライバルの解除に失敗しました。");
						}else{
							rival_list[num].rivalsp = false;
							viewList();
						}
					}catch(e){
						alert("ライバルの解除に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	if(rival_list[num].rivalsp){
		unregist();
	}else{
		regist();
	}
}

changeRivalDP = function(num){
	function regist(){
		var req = new XMLHttpRequest();
		req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_active.html?daflg=1&send=send&rival=' + rival_list[num].hash , true);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "設定を更新しました") == -1){
							var total = 0;
							for(var i=0; i<rival_list.length; i++){
								if(rival_list[i].rivaldp){
									total++;
								}
							}
							if(total<5){
								alert("ライバルの登録に失敗しました。");
							}else{
								alert("ライバルの登録に失敗しました。\nDPライバルが既に5件設定されている可能性があります。");
							}
						}else{
							rival_list[num].rivaldp = true;
							viewList();
						}
					}catch(e){
						alert("ライバルの登録に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	function unregist(){
		var req = new XMLHttpRequest();
		req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_active.html?daflg=2&send=send&rival=' + rival_list[num].hash , true);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "設定を更新しました") == -1){
							alert("ライバルの解除に失敗しました。");
						}else{
							rival_list[num].rivaldp = false;
							viewList();
						}
					}catch(e){
						alert("ライバルの解除に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	if(rival_list[num].rivaldp){
		unregist();
	}else{
		regist();
	}
}

changeCourse = function(num){
	function regist(){
		var req = new XMLHttpRequest();
		req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/originalcourse/fcourse_regist.html?fid=' + rival_list[num].course_id , true);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "フォローコースが登録されました。") == -1){
							var tmp = 0;
							for(var i=0; i<rival_list.length; i++){
								if(rival_list[i].course_active){
									tmp++;
								}
							}
							if(tmp >= 5){
								alert("フォローコースの登録に失敗しました。\n既にフォローコースが5件登録されている恐れがあります。");
							}else{
								alert("フォローコースの登録に失敗しました。");
							}
						}else{
							rival_list[num].course_active = true;
							viewList();
						}
					}catch(e){
						alert("フォローコースの登録に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	function unregist(){
		var req = new XMLHttpRequest();
		req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/originalcourse/followcourse_cancel.html?fid=' + rival_list[num].course_id , true);
		req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");
						if(matchWordLine(res, "フォローコースが解除されました。") == -1){
							alert("フォローコースの解除に失敗しました。");
						}else{
							rival_list[num].course_active = false;
							viewList();
						}
					}catch(e){
						alert("フォローコースの解除に失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}

	if(rival_list[num].course_active){
		unregist();
	}else{
		regist();
	}
}

changeMemo = function(num){
	var tmp = "";
	try{
		if(rival_list[num].memo != undefined){
			tmp = rival_list[num].memo;
		}
	}catch(e){}
	var memo = prompt("メモを入力してください。", tmp);
	if(memo != null){
		rival_list[num].memo = memo;
	}
	viewList();
}

daniStrToNum = function(str){
	switch(str){
		case "皆伝": return 18;
		case "十段": return 17;
		case "九段": return 16;
		case "八段": return 15;
		case "七段": return 14;
		case "六段": return 13;
		case "五段": return 12;
		case "四段": return 11;
		case "三段": return 10;
		case "二段": return 9;
		case "初段": return 8;
		case "1級" : return 7;
		case "2級" : return 6;
		case "3級" : return 5;
		case "4級" : return 4;
		case "5級" : return 3;
		case "6級" : return 2;
		case "7級" : return 1;
		case "--"  : return 0;
		default    : return -1;
	}
}

daniNumToStr = function(num){
	switch(num){
		case 18: return "皆伝";
		case 17: return "十段";
		case 16: return "九段";
		case 15: return "八段";
		case 14: return "七段";
		case 13: return "六段";
		case 12: return "五段";
		case 11: return "四段";
		case 10: return "三段";
		case 9 : return "二段";
		case 8 : return "初段";
		case 7 : return "1級";
		case 6 : return "2級";
		case 5 : return "3級";
		case 4 : return "4級";
		case 3 : return "5級";
		case 2 : return "6級";
		case 1 : return "7級";
		case 0 : return "--" ;
		default: return "ERROR";
	}
}

readList = function(){
	mainTab.contentDocument.getElementById('data').innerHTML = "読み込み中です。";
	for(var i=0; i<rival_list.length; i++){
		deleteErrorStatus(i);
	}
	readMyData();
	readFollowList(0);
//	viewSource(4);

	return;
}

deleteErrorStatus = function(i){
	if(rival_list[i].danisp == "ERROR"){
		delete rival_list[i].danisp;
	}
	if(rival_list[i].danidp == "ERROR"){
		delete rival_list[i].danidp;
	}
	if((isNaN(rival_list[i].djpsp))||(typeof rival_list[i].djpsp != "number")){
		delete rival_list[i].djpsp;
	}
	if((isNaN(rival_list[i].djpdp))||(typeof rival_list[i].djpdp != "number")){
		delete rival_list[i].djpdp;
	}

	return;
}

readStatus = function(opt, num, rest, all){
	function readNext(){
		if(num == 0){
			viewList();
			alert("読み込みが完了しました。");
		}else{
			readStatus(opt, num-1, rest, all);
		}
		return;
	}

	mainTab.contentDocument.getElementById('data').innerHTML = "ステータス読み込み中です。<BR>\n残り " + rest + " / " + all + " ユーザー";
	readMyData();
	if((opt==1)&&(typeof rival_list[num].danisp != "undefined")&&(typeof rival_list[num].danidp != "undefined")&&(typeof rival_list[num].djpsp != "undefined")&&(typeof rival_list[num].djpdp != "undefined")&&(typeof rival_list[num].comment != "undefined")&&(typeof rival_list[num].area != "undefined")){
		readNext();
	}else{
		var req = new XMLHttpRequest();
		req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/data_another.html?rival=' + rival_list[num].hash , true);
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");

						if(matchWordLine(res, "マイページ") != -1){
							if(matchWordLine(res, "加入が必要です") == -1){
								var tmp = matchWordLine(res, "所属都道府県</th");
								rival_list[num].area = (trim(res[tmp+2].split("<")[0]));
								var tmp = matchWordLine(res, "所属店舗</th");
								rival_list[num].shop = (trim(res[tmp+2].split("<")[0]));

								tmp = matchWordLine(res, "DJ POINT</th", tmp);
								tmp = matchWordLine(res, "SP</td", tmp);
								rival_list[num].djpsp = Number(trim(res[tmp+2].split("pt.")[0]));
								tmp = matchWordLine(res, "DP</td", tmp);
								rival_list[num].djpdp = Number(trim(res[tmp+2].split("pt.")[0]));

								tmp = matchWordLine(res, "段位認定</th", tmp);
								tmp = matchWordLine(res, "SP</td", tmp);
								rival_list[num].danisp = daniStrToNum(trim(res[tmp+2].split("<")[0]));
								tmp = matchWordLine(res, "DP</td", tmp);
								rival_list[num].danidp = daniStrToNum(trim(res[tmp+2].split("<")[0]));

								tmp = matchWordLine(res, "コメント</th", tmp);
								tmp = matchWordLine(res, 'class="ano"', tmp);
								rival_list[num].comment = trim(res[tmp+1].split("<")[0]);

								rest--;
								readNext();
							}else{
								viewList();
								alert("ユーザーステータスの読み込みに失敗しました。\n公式サイトからのユーザーリスト読み込みを再度行ってください。");
							}
						}else{
							viewList();
							alert("ユーザーステータスの読み込みに失敗しました。\nログインしていない可能性があります。");
						}
					}catch(e){
						alert("ユーザーステータスの読み込みに失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}
	return;
}

readCourse = function(){
	mainTab.contentDocument.getElementById('data').innerHTML = "ユーザーコース設定状態を読み込み中です。";
	readMyData();
	var req = new XMLHttpRequest();
	req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/originalcourse/follow.html', true);
	req.onreadystatechange = function (aEvt){
		if(req.readyState == 4){
			if(req.status == 200){
				try{
					var res = req.responseText.split(">");

					if(matchWordLine(res, "マイページ") != -1){
						if(matchWordLine(res, "加入が必要です") == -1){
							for(var i=0; i<rival_list.length; i++){
								rival_list[i].course_active = false;
							}

							var txt = "";
							for(var i=0;i<5;i++){
								var tmp = matchWordLine(res, "<change"+(i+1));
								if(tmp != -1){
									var tmp2 = matchWordLine(res, "fid", tmp);
									var id = res[tmp2].split("\"")[3];
									for(var j=0; j<rival_list.length; j++){
										try{
											if(rival_list[j].course_id == id){
												rival_list[j].course_active = true;
												break;
											}
										}catch(e){}
									}
									if(j==rival_list.length){
										txt += res[tmp-1].split("<")[0] + "\n";
									}
								}
							}

							viewList();
							if(txt != ""){
								txt = "\n\n以下のDJ NAMEの人のフォローコースを設定しているようですが、IDが見つかりませんでした。\n" + txt;
							}
							alert("ユーザーコース設定状態の読み込みが完了しました。" + txt);
						}else{
							viewList();
							alert("ユーザーコース設定状態の読み込みに失敗しました。\n公式サイトからのユーザーリスト読み込みを再度行ってください。");
						}
					}else{
						viewList();
						alert("ユーザーコース設定状態の読み込みに失敗しました。\nログインしていない可能性があります。");
					}
				}catch(e){
					alert("ユーザーコース設定状態の読み込みに失敗しました。\n" + e);
				}
			}
		}
	};
	req.send(null);

	return;
}

readCourseID = function(opt, num, rest, all){
	function readNext(){
		if(num == 0){
			viewList();
			alert("読み込みが完了しました。");
		}else{
			readCourseID(opt, num-1, rest, all);
		}
		return;
	}

	mainTab.contentDocument.getElementById('data').innerHTML = "ユーザーコースID読み込み中です。<BR>\n残り " + rest + " / " + all + " ユーザー";
	if((opt==0)&&(typeof rival_list[num].course_id != "undefined")){
		readNext();
	}else{
		var req = new XMLHttpRequest();
		req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/originalcourse/other_courseinfo.html?rival=' + rival_list[num].hash , true);
		req.onreadystatechange = function (aEvt){
			if(req.readyState == 4){
				if(req.status == 200){
					try{
						var res = req.responseText.split(">");

						if(matchWordLine(res, "マイページ") != -1){
							if(matchWordLine(res, "加入が必要です") == -1){
								var tmp = matchWordLine(res, "fcourse_regist.html");
								if(tmp != -1){
									tmp = matchWordLine(res, "fid", tmp);
									rival_list[num].course_id = res[tmp].split("\"")[3];
								}

								rest--;
								readNext();
							}else{
								viewList();
								alert("ユーザーコースIDの読み込みに失敗しました。\n公式サイトからのユーザーリスト読み込みを再度行ってください。");
							}
						}else{
							viewList();
							alert("ユーザーコースIDの読み込みに失敗しました。\nログインしていない可能性があります。");
						}
					}catch(e){
						alert("ユーザーコースIDの読み込みに失敗しました。\n" + e);
					}
				}
			}
		};
		req.send(null);
	}
	return;
}

readIIDXID = function(id){
	readMyData();
	id = id.replace("-", "");
	for(var i=0; i<rival_list.length; i++){
		if(id == rival_list[i].iidxid.replace("-", "")){
			alert(rival_list[i].djname + "[" + rival_list[i].iidxid + "]は既にリスト中にあります。(DEFAULTソート:" + i + "番)");
			return;
		}
	}

	var req1 = new XMLHttpRequest();
	req1.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
	req1.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
	req1.onreadystatechange = function (aEvt) {
		if(req1.readyState == 4) {
			if(req1.status == 200){
				var res = req1.responseText;
				if(res.search(/加入が必要です/) != -1){//未課金時
					if(confirm("公式サイトからの読み込みができません。\ne-AMUSEMENT ベーシックコースに加入していない可能性があります。\n公式サイトを開きますか？")){
						gBrowser.selectedTab = gBrowser.addTab("http://p.eagate.573.jp/game/2dx/22/p/");
					}
				}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
					if(confirm("公式サイトからの読み込みができません。\nログインが完了していないか、公式サイトがメンテナンス中の可能性があります。\n公式サイトを開きますか？")){
						gBrowser.selectedTab = gBrowser.addTab("http://p.eagate.573.jp/game/2dx/22/p/");
					}
				}else if(res.search(/マイページ/) != -1){//ログイン時
					var res = req1.responseText.split(">");
					var tmp = "data_another.html";
					var line = matchWordLine(res, tmp);
					if(line != -1){
						var tmp_rival = new Object();
						tmp_rival.hash = res[line].split("\"")[1].split("=")[1];
						tmp_rival.djname = trim(res[line+1].split("<")[0]);
						tmp_rival.iidxid = trim(res[line+4].split("<")[0]);
						tmp_rival.danisp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[0]));
						tmp_rival.danidp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[1]));
						tmp_rival.area = trim(res[line+8].split("<")[0]);
						tmp_rival.follow = false;
						tmp_rival.follower = false;
						tmp_rival.rivalsp = false;
						tmp_rival.rivaldp = false;
						tmp_rival.rev_rivalsp = false;
						tmp_rival.rev_rivaldp = false;
						rival_list.push(tmp_rival);

						alert(tmp_rival.djname + "[" + tmp_rival.iidxid + "]を追加しました。");
						viewList();
					}else{
						alert("該当するIIDX IDが見つかりませんでした。");
					}
				}else{
					if(confirm("公式サイトからの読み込みができません。\nログインが完了していないか、公式サイトがメンテナンス中の可能性があります。\n公式サイトを開きますか？")){
						gBrowser.selectedTab = gBrowser.addTab("http://p.eagate.573.jp/game/2dx/22/p/");
					}
				}
			}else{
				alert("公式サイトからの読み込みができませんした。");
			}
		}
	};
	req1.send("mode=1&iidxid=" + id);

	return;
}

readText = function(flag){
	//参考 http://piro.sakura.ne.jp/xul/tips/x0021.html
	var filename = "FollowEditorIIDX22.txt";
	//参考 http://kittttttan.web.fc2.com/xul/extension4.html
	// オブジェクト生成
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", Components.interfaces.nsIFilePicker.modeOpen);
	fp.defaultString = filename;
	var result = fp.show();
	if(result == nsIFilePicker.returnOK){
		var thefile = fp.file;
		// 文字コード指定
		var charset = 'UTF-8';
		// ファイルストリーム生成
		var fileStream = Components.classes['@mozilla.org/network/file-input-stream;1']
		.createInstance(Components.interfaces.nsIFileInputStream);
		// 読み込み専用で初期化
		fileStream.init(thefile, 1, 0, false);
		// 文字列書込みストリーム生成
		var converterStream = Components.classes['@mozilla.org/intl/converter-input-stream;1']
		.createInstance(Components.interfaces.nsIConverterInputStream);
		// 文字列書込みストリーム初期化
		converterStream.init(fileStream, charset, fileStream.available(),
		Components.interfaces.nsIConverterOutputStream.DEFAULT_REPLACEMENT_CHARACTER);
		// 文字列書込み
		var out = {};
		converterStream.readString(fileStream.available(), out);
		var fileContents = out.value;

		var reg = new RegExp("%23", "g");
		var content = fileContents.replace(reg, "#");
		content = content.replace(/\r\n/g, "\n");
		content = content.replace(/\r/g, "\n");
		content = content.split("\n");

		for(var i=0; i<content.length; i++){
			var id = content[i].substr(0,9).match(/[0-9]{4}-[0-9]{4}|[0-9]{8}/);
			if(id != null){
				id = "" + id;
				id = id.replace("-", "");
				id = id.substr(0,4).concat("-").concat(id.substr(4,4));
				for(var j=0; j<rival_list.length; j++){
					if(id == rival_list[j].iidxid){
						break;
					}
				}
				var tmp = content[i].match(/[0-9]{4}-[0-9]{4}[\s]*/);
				var memo = content[i].replace(tmp, "");
				if(j != rival_list.length){
					rival_list[j].memo = memo;
				}else if(flag){
					var rival = new Object();
					rival.iidxid = id;
					rival.follow = false;
					rival.follower = false;
					rival.rivalsp = false;
					rival.rivaldp = false;
					rival.rev_rivalsp = false;
					rival.rev_rivaldp = false;
					rival.memo = memo;
					rival_list.push(rival);
				}
			}
		}

		// 文字列書込みストリームクローズ
		converterStream.close();
		// ファイルストリームクローズ
		fileStream.close();

		viewList();
		alert("ファイル読み込みが完了しました。");
	}
}

writeText = function(){
	//参考 https://developer.mozilla.org/ja/XUL_Tutorial/Open_and_Save_Dialogs
	//参考 http://efcl.info/2009/0813/res1249/
	//参考 http://piro.sakura.ne.jp/xul/tips/x0022.html
	var filename = "FollowEditorIIDX22.txt";
	var reg = new RegExp("#", "g");
	var content = "";
	for(var i=0; i<rival_list.length; i++){
		content += rival_list[i].iidxid + " ";
		if(rival_list[i].memo != undefined){
			content += rival_list[i].memo + "\r\n";
		}else{
			content += "\r\n";
		}
	}
	content = content.replace(reg, "%23");
	// オブジェクト生成
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, "Select a File", Components.interfaces.nsIFilePicker.modeSave);
	fp.defaultString = filename;
	var result = fp.show();
	if((result == nsIFilePicker.returnOK)||(result == nsIFilePicker.returnReplace)){
		var thefile = fp.file;
		// 文字コード指定
		var charset = 'UTF-8';
		// 書込む文字列
		var string = content;
		// ファイルストリーム生成
		var fileStream = Components.classes['@mozilla.org/network/file-output-stream;1']
		.createInstance(Components.interfaces.nsIFileOutputStream);
		// 書込み専用で初期化
		fileStream.init(thefile, 0x2a, 0x775, false);
		// 文字列書込みストリーム生成
		var converterStream = Components.classes['@mozilla.org/intl/converter-output-stream;1']
		.createInstance(Components.interfaces.nsIConverterOutputStream);
		// 文字列書込みストリーム初期化
		converterStream.init(fileStream, charset, string.length,
		Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);
		// 文字列書込み
		converterStream.writeString(string);
		// 文字列書込みストリームクローズ
		converterStream.close();
		// ファイルストリームクローズ
		fileStream.close();
	}
}

readHash = function(num, rest, all){
	readMyData();
	function readNext(){
		if(num == 0){
			viewList();
			alert("読み込みが完了しました。");
		}else{
			readHash(num-1, rest, all);
		}
		return;
	}

	mainTab.contentDocument.getElementById('data').innerHTML = "ユーザーハッシュ読み込み中です。<BR>\n残り " + rest + " / " + all + " ユーザー";
	if((rival_list[num].follow)||(rival_list[num].follower)||(rival_list[num].rivalsp)||(rival_list[num].rivaldp)||(rival_list[num].rev_rivalsp)||(rival_list[num].rev_rivaldp)){
		readNext();
	}else{
		var id = rival_list[num].iidxid.replace("-", "");

		var req1 = new XMLHttpRequest();
		req1.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
		req1.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		req1.onreadystatechange = function (aEvt) {
			if(req1.readyState == 4) {
				if(req1.status == 200){
					var res = req1.responseText;
					if(res.search(/加入が必要です/) != -1){//未課金時
						if(confirm("公式サイトからの読み込みができません。\ne-AMUSEMENT ベーシックコースに加入していない可能性があります。\n公式サイトを開きますか？")){
							gBrowser.selectedTab = gBrowser.addTab("http://p.eagate.573.jp/game/2dx/22/p/");
						}
					}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
						if(confirm("公式サイトからの読み込みができません。\nログインが完了していないか、公式サイトがメンテナンス中の可能性があります。\n公式サイトを開きますか？")){
							gBrowser.selectedTab = gBrowser.addTab("http://p.eagate.573.jp/game/2dx/22/p/");
						}
					}else if(res.search(/マイページ/) != -1){//ログイン時
						var res = req1.responseText.split(">");
						var tmp = "data_another.html";
						var line = matchWordLine(res, tmp);
						if(line != -1){
							rival_list[num].hash = res[line].split("\"")[1].split("=")[1];
							rival_list[num].djname = trim(res[line+1].split("<")[0]);
							rival_list[num].iidxid = trim(res[line+4].split("<")[0]);
							rival_list[num].danisp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[0]));
							rival_list[num].danidp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[1]));
							rival_list[num].area = trim(res[line+8].split("<")[0]);

							rest--;
							readNext();
						}else{
							rival_list[num].hash = 'no-exist';
							rest--;
							readNext();
						}
					}else{
						viewList();
						alert("公式サイトへの接続に失敗しました。");
					}
				}else{
					alert("公式サイトへの接続に失敗しました。");
				}
			}
		};
		req1.send("mode=1&iidxid=" + id);
	}

	return;
}

readPrevVersion = function(opt){
	if(opt.version == 19){
		try{
			fe19_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			fe19_Branch = fe19_prefs.getBranch("extensions.FollowEditerForIIDX19.");

			try{
				var sv19_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				var sv19_Branch = sv19_prefs.getBranch("extensions.ScoreViewerForIIDX19.");
				var rival_data_sv19 = JSON.parse(sv19_Branch.getCharPref("rival_data"));

				var sv22_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				var sv22_Branch = sv22_prefs.getBranch("extensions.ScoreViewerForIIDX22.");
				var rival_data_sv22 = JSON.parse(sv22_Branch.getCharPref("rival_data"));
			}catch(e){
				opt.rival_sv = false;
			}

			var follow_list = new Array();

			var dver = fe19_Branch.getCharPref("data_version");
			if(dver != data_version_fe19){
				alert('Follow Editor for beatmaniaIIDX 19 Lincleのデータが古く読み込めません。\n最新のバージョンを起動してからお試しください。');
			}else{
				rlist = JSON.parse(decodeURIComponent(escape(fe19_Branch.getCharPref("rival_list"))));
				for(var i in rlist){
					for(var j=0; j<rival_list.length; j++){
						if(rlist[i].iidxid == rival_list[j].iidxid){
							break;
						}
					}
					if(j == rival_list.length){
						//追加
						var obj = new Object();
						obj.djname = rlist[i].djname;
						obj.iidxid = rlist[i].iidxid;
						obj.hash = 'no-exist';
						if(opt.memo){
							obj.memo = rlist[i].memo;
						}
						rival_list.push(obj);
						if(opt.follow){
							if(rlist[i].follow){
								follow_list.push(j);
							}
						}
						if(opt.rival_sv){
							var f1 = false;
							var f2 = false;
							for(var k=0; k<rival_data_sv19.length; k++){
								if(rival_data_sv19[k].id == rival_list[j].iidxid){
									f1 = true;
									break;
								}
							}
							for(var k=0; k<rival_data_sv22.length; k++){
								if(rival_data_sv22[k].id == rival_list[j].iidxid){
									f2 = true;
									break;
								}
							}
							if((f1)&&(!(f2))){
								changeRivalScoreViewer(j);
							}
						}
					}else{
						//更新
						if(opt.memo){
							if((rival_list[j].memo == undefined)||(rival_list[j].memo == '')){
								rival_list[j].memo = rlist[i].memo;
							}else{
								rival_list[j].memo = rlist[i].memo + '<BR>' + rival_list[j].memo;
							}
						}
						if(opt.follow){
							if(rlist[i].follow){
								if(!(rival_list[j].follow)){
									follow_list.push(j);
								}
							}
						}
						if(opt.rival_sv){
							var f1 = false;
							var f2 = false;
							for(var k=0; k<rival_data_sv19.length; k++){
								if(rival_data_sv19[k].id == rival_list[j].iidxid){
									f1 = true;
									break;
								}
							}
							for(var k=0; k<rival_data_sv22.length; k++){
								if(rival_data_sv22[k].id == rival_list[j].iidxid){
									f2 = true;
									break;
								}
							}
							if((f1)&&(!(f2))){
								changeRivalScoreViewer(j);
							}
						}
					}
				}
				if(opt.follow){
					var failed_list = new Array();
					var readNext = function(){
						if(follow_list.length == 0){
							viewList();
							var txt = 'Follow Editor for beatmaniaIIDX 19 Lincleからの引継ぎが完了しました。';
							if(failed_list.length != 0){
								txt += '\n\n以下のユーザーはフォローできませんでした。\n(既にフォローしている場合もエラーになります。)';
								for(var k=0; k<failed_list.length; k++){
									txt += '\n' + (failed_list[k] + 1);
									txt += ':' + rival_list[failed_list[k]].djname;
									txt += '(' + rival_list[failed_list[k]].iidxid + ')';
								}
							}
							alert(txt);
						}else{
							mainTab.contentDocument.getElementById('data').innerHTML = "フォロー状態変更中です。<BR>\n残り " + follow_list.length + " ユーザー";
							var num = follow_list.shift();
							searchID(num);
						}
						return;
					}
					var follow = function(num){
						var req = new XMLHttpRequest();
						req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_register.html?rival=' + rival_list[num].hash + '&regist=1&cmp=1' , true);
						req.onreadystatechange = function (aEvt){
							if(req.readyState == 4){
								if(req.status == 200){
									try{
										var res = req.responseText.split(">");
										if(matchWordLine(res, "フォロー登録しました") == -1){
											failed_list.push(num);
											readNext();
										}else{
											rival_list[num].follow = true;
											readNext();
										}
									}catch(e){
										failed_list.push(num);
										readNext();
									}
								}
							}
						};
						req.send(null);
					}
					var searchID = function(num){
						var id = rival_list[num].iidxid.replace("-", "");

						var req = new XMLHttpRequest();
						req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
						req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
						req.onreadystatechange = function (aEvt) {
							if(req.readyState == 4) {
								if(req.status == 200){
									var res = req.responseText;
									if(res.search(/加入が必要です/) != -1){//未課金時
										failed_list.push(num);
										readNext();
									}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
										failed_list.push(num);
										readNext();
									}else if(res.search(/マイページ/) != -1){//ログイン時
										var res = req.responseText.split(">");
										var tmp = "data_another.html";
										var line = matchWordLine(res, tmp);
										if(line != -1){
											rival_list[num].hash = res[line].split("\"")[1].split("=")[1];
											rival_list[num].djname = trim(res[line+1].split("<")[0]);
											rival_list[num].iidxid = trim(res[line+6].split("<")[0]);
											rival_list[num].danisp = daniStrToNum(trim(res[line+10].split("<")[0].split("/")[0]));
											rival_list[num].danidp = daniStrToNum(trim(res[line+10].split("<")[0].split("/")[1]));
											rival_list[num].area = trim(res[line+14].split("<")[0]);

											follow(num);
										}else{
											failed_list.push(num);
											readNext();
										}
									}else{
										failed_list.push(num);
										readNext();
									}
								}else{
									failed_list.push(num);
									readNext();
								}
							}
						};
						req.send("mode=1&iidxid=" + id);
					}
					//main
					var req = new XMLHttpRequest();
					req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
					req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
					req.onreadystatechange = function (aEvt) {
						if(req.readyState == 4) {
							if(req.status == 200){
								var res = req.responseText;
								if(res.search(/加入が必要です/) != -1){//未課金時
									viewList();
									alert('Follow Editor for beatmaniaIIDX 19 Lincleからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
									viewList();
									alert('Follow Editor for beatmaniaIIDX 19 Lincleからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}else if(res.search(/マイページ/) != -1){//ログイン時
									readNext();
								}else{
									viewList();
									alert('Follow Editor for beatmaniaIIDX 19 Lincleからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}
							}else{
								viewList();
								alert('Follow Editor for beatmaniaIIDX 19 Lincleからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
							}
						}
					};
					req.send(null);
				}else{
					viewList();
					alert('Follow Editor for beatmaniaIIDX 19 Lincleからの引継ぎが完了しました。');
				}
			}
		}catch(e){
			viewList();
			alert('Follow Editor for beatmaniaIIDX 19 Lincleのデータがないか、データが壊れています。');
		}
	}else if(opt.version == 20){
		try{
			fe20_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			fe20_Branch = fe20_prefs.getBranch("extensions.FollowEditorForIIDX20.");

			try{
				var sv20_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				var sv20_Branch = sv20_prefs.getBranch("extensions.ScoreViewerForIIDX20.");
				var rival_data_sv20 = JSON.parse(sv20_Branch.getCharPref("rival_data"));

				var sv22_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				var sv22_Branch = sv22_prefs.getBranch("extensions.ScoreViewerForIIDX22.");
				var rival_data_sv22 = JSON.parse(sv22_Branch.getCharPref("rival_data"));
			}catch(e){
				opt.rival_sv = false;
			}

			var follow_list = new Array();

			var dver = fe20_Branch.getCharPref("data_version");
			if(dver != data_version_fe20){
				alert('Follow Editor for beatmaniaIIDX 20 tricoroのデータが古く読み込めません。\n最新のバージョンを起動してからお試しください。');
			}else{
				rlist = JSON.parse(decodeURIComponent(escape(fe20_Branch.getCharPref("rival_list"))));
				for(var i in rlist){
					for(var j=0; j<rival_list.length; j++){
						if(rlist[i].iidxid == rival_list[j].iidxid){
							break;
						}
					}
					if(j == rival_list.length){
						//追加
						var obj = new Object();
						obj.djname = rlist[i].djname;
						obj.iidxid = rlist[i].iidxid;
						obj.hash = 'no-exist';
						if(opt.memo){
							obj.memo = rlist[i].memo;
						}
						rival_list.push(obj);
						if(opt.follow){
							if(rlist[i].follow){
								follow_list.push(j);
							}
						}
						if(opt.rival_sv){
							var f1 = false;
							var f2 = false;
							for(var k=0; k<rival_data_sv20.length; k++){
								if(rival_data_sv20[k].id == rival_list[j].iidxid){
									f1 = true;
									break;
								}
							}
							for(var k=0; k<rival_data_sv22.length; k++){
								if(rival_data_sv22[k].id == rival_list[j].iidxid){
									f2 = true;
									break;
								}
							}
							if((f1)&&(!(f2))){
								changeRivalScoreViewer(j);
							}
						}
					}else{
						//更新
						if(opt.memo){
							if((rival_list[j].memo == undefined)||(rival_list[j].memo == '')){
								rival_list[j].memo = rlist[i].memo;
							}else{
								rival_list[j].memo = rlist[i].memo + '<BR>' + rival_list[j].memo;
							}
						}
						if(opt.follow){
							if(rlist[i].follow){
								if(!(rival_list[j].follow)){
									follow_list.push(j);
								}
							}
						}
						if(opt.rival_sv){
							var f1 = false;
							var f2 = false;
							for(var k=0; k<rival_data_sv20.length; k++){
								if(rival_data_sv20[k].id == rival_list[j].iidxid){
									f1 = true;
									break;
								}
							}
							for(var k=0; k<rival_data_sv22.length; k++){
								if(rival_data_sv22[k].id == rival_list[j].iidxid){
									f2 = true;
									break;
								}
							}
							if((f1)&&(!(f2))){
								changeRivalScoreViewer(j);
							}
						}
					}
				}
				if(opt.follow){
					var failed_list = new Array();
					var readNext = function(){
						if(follow_list.length == 0){
							viewList();
							var txt = 'Follow Editor for beatmaniaIIDX 20 tricoroからの引継ぎが完了しました。';
							if(failed_list.length != 0){
								txt += '\n\n以下のユーザーはフォローできませんでした。\n(既にフォローしている場合もエラーになります。)';
								for(var k=0; k<failed_list.length; k++){
									txt += '\n' + (failed_list[k] + 1);
									txt += ':' + rival_list[failed_list[k]].djname;
									txt += '(' + rival_list[failed_list[k]].iidxid + ')';
								}
							}
							alert(txt);
						}else{
							mainTab.contentDocument.getElementById('data').innerHTML = "フォロー状態変更中です。<BR>\n残り " + follow_list.length + " ユーザー";
							var num = follow_list.shift();
							searchID(num);
						}
						return;
					}
					var follow = function(num){
						var req = new XMLHttpRequest();
						req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_register.html?rival=' + rival_list[num].hash + '&regist=1&cmp=1' , true);
						req.onreadystatechange = function (aEvt){
							if(req.readyState == 4){
								if(req.status == 200){
									try{
										var res = req.responseText.split(">");
										if(matchWordLine(res, "フォロー登録しました") == -1){
											failed_list.push(num);
											readNext();
										}else{
											rival_list[num].follow = true;
											readNext();
										}
									}catch(e){
										failed_list.push(num);
										readNext();
									}
								}
							}
						};
						req.send(null);
					}
					var searchID = function(num){
						var id = rival_list[num].iidxid.replace("-", "");

						var req = new XMLHttpRequest();
						req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
						req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
						req.onreadystatechange = function (aEvt) {
							if(req.readyState == 4) {
								if(req.status == 200){
									var res = req.responseText;
									if(res.search(/加入が必要です/) != -1){//未課金時
										failed_list.push(num);
										readNext();
									}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
										failed_list.push(num);
										readNext();
									}else if(res.search(/マイページ/) != -1){//ログイン時
										var res = req.responseText.split(">");
										var tmp = "data_another.html";
										var line = matchWordLine(res, tmp);
										if(line != -1){
											rival_list[num].hash = res[line].split("\"")[1].split("=")[1];
											rival_list[num].djname = trim(res[line+1].split("<")[0]);
											rival_list[num].iidxid = trim(res[line+4].split("<")[0]);
											rival_list[num].danisp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[0]));
											rival_list[num].danidp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[1]));
											rival_list[num].area = trim(res[line+8].split("<")[0]);

											follow(num);
										}else{
											failed_list.push(num);
											readNext();
										}
									}else{
										failed_list.push(num);
										readNext();
									}
								}else{
									failed_list.push(num);
									readNext();
								}
							}
						};
						req.send("mode=1&iidxid=" + id);
					}
					//main
					var req = new XMLHttpRequest();
					req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
					req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
					req.onreadystatechange = function (aEvt) {
						if(req.readyState == 4) {
							if(req.status == 200){
								var res = req.responseText;
								if(res.search(/加入が必要です/) != -1){//未課金時
									viewList();
									alert('Follow Editor for beatmaniaIIDX 20 tricoroからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
									viewList();
									alert('Follow Editor for beatmaniaIIDX 20 tricoroからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}else if(res.search(/マイページ/) != -1){//ログイン時
									readNext();
								}else{
									viewList();
									alert('Follow Editor for beatmaniaIIDX 20 tricoroからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}
							}else{
								viewList();
								alert('Follow Editor for beatmaniaIIDX 20 tricoroからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
							}
						}
					};
					req.send(null);
				}else{
					viewList();
					alert('Follow Editor for beatmaniaIIDX 20 tricoroからの引継ぎが完了しました。');
				}
			}
		}catch(e){
			viewList();
//			alert('Follow Editor for beatmaniaIIDX 20 tricoroのデータがないか、データが壊れています。');
			alert(e + '\n\nFollow Editor for beatmaniaIIDX 20 tricoroのデータがないか、データが壊れています。');
		}
	}else if(opt.version == 21){
		try{
			fe21_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
			fe21_Branch = fe21_prefs.getBranch("extensions.FollowEditorForIIDX21.");

			try{
				var sv21_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				var sv21_Branch = sv21_prefs.getBranch("extensions.ScoreViewerForIIDX21.");
				var rival_data_sv21 = JSON.parse(sv21_Branch.getCharPref("rival_data"));

				var sv22_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
				var sv22_Branch = sv22_prefs.getBranch("extensions.ScoreViewerForIIDX22.");
				var rival_data_sv22 = JSON.parse(sv22_Branch.getCharPref("rival_data"));
			}catch(e){
				opt.rival_sv = false;
			}

			var follow_list = new Array();

			var dver = fe21_Branch.getCharPref("data_version");
			if(dver != data_version_fe21){
				alert('Follow Editor for beatmaniaIIDX 21 SPADAのデータが古く読み込めません。\n最新のバージョンを起動してからお試しください。');
			}else{
				rlist = JSON.parse(decodeURIComponent(escape(fe21_Branch.getCharPref("rival_list"))));
				for(var i in rlist){
					for(var j=0; j<rival_list.length; j++){
						if(rlist[i].iidxid == rival_list[j].iidxid){
							break;
						}
					}
					if(j == rival_list.length){
						//追加
						var obj = new Object();
						obj.djname = rlist[i].djname;
						obj.iidxid = rlist[i].iidxid;
						obj.hash = 'no-exist';
						if(opt.memo){
							obj.memo = rlist[i].memo;
						}
						rival_list.push(obj);
						if(opt.follow){
							if(rlist[i].follow){
								follow_list.push(j);
							}
						}
						if(opt.rival_sv){
							var f1 = false;
							var f2 = false;
							for(var k=0; k<rival_data_sv21.length; k++){
								if(rival_data_sv21[k].id == rival_list[j].iidxid){
									f1 = true;
									break;
								}
							}
							for(var k=0; k<rival_data_sv22.length; k++){
								if(rival_data_sv22[k].id == rival_list[j].iidxid){
									f2 = true;
									break;
								}
							}
							if((f1)&&(!(f2))){
								changeRivalScoreViewer(j);
							}
						}
					}else{
						//更新
						if(opt.memo){
							if((rival_list[j].memo == undefined)||(rival_list[j].memo == '')){
								rival_list[j].memo = rlist[i].memo;
							}else{
								rival_list[j].memo = rlist[i].memo + '<BR>' + rival_list[j].memo;
							}
						}
						if(opt.follow){
							if(rlist[i].follow){
								if(!(rival_list[j].follow)){
									follow_list.push(j);
								}
							}
						}
						if(opt.rival_sv){
							var f1 = false;
							var f2 = false;
							for(var k=0; k<rival_data_sv21.length; k++){
								if(rival_data_sv21[k].id == rival_list[j].iidxid){
									f1 = true;
									break;
								}
							}
							for(var k=0; k<rival_data_sv22.length; k++){
								if(rival_data_sv22[k].id == rival_list[j].iidxid){
									f2 = true;
									break;
								}
							}
							if((f1)&&(!(f2))){
								changeRivalScoreViewer(j);
							}
						}
					}
				}
				if(opt.follow){
					var failed_list = new Array();
					var readNext = function(){
						if(follow_list.length == 0){
							viewList();
							var txt = 'Follow Editor for beatmaniaIIDX 21 SPADAからの引継ぎが完了しました。';
							if(failed_list.length != 0){
								txt += '\n\n以下のユーザーはフォローできませんでした。\n(既にフォローしている場合もエラーになります。)';
								for(var k=0; k<failed_list.length; k++){
									txt += '\n' + (failed_list[k] + 1);
									txt += ':' + rival_list[failed_list[k]].djname;
									txt += '(' + rival_list[failed_list[k]].iidxid + ')';
								}
							}
							alert(txt);
						}else{
							mainTab.contentDocument.getElementById('data').innerHTML = "フォロー状態変更中です。<BR>\n残り " + follow_list.length + " ユーザー";
							var num = follow_list.shift();
							searchID(num);
						}
						return;
					}
					var follow = function(num){
						var req = new XMLHttpRequest();
						req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/djdata/rival_register.html?rival=' + rival_list[num].hash + '&regist=1&cmp=1' , true);
						req.onreadystatechange = function (aEvt){
							if(req.readyState == 4){
								if(req.status == 200){
									try{
										var res = req.responseText.split(">");
										if(matchWordLine(res, "フォロー登録しました") == -1){
											failed_list.push(num);
											readNext();
										}else{
											rival_list[num].follow = true;
											readNext();
										}
									}catch(e){
										failed_list.push(num);
										readNext();
									}
								}
							}
						};
						req.send(null);
					}
					var searchID = function(num){
						var id = rival_list[num].iidxid.replace("-", "");

						var req = new XMLHttpRequest();
						req.open('POST', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
						req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
						req.onreadystatechange = function (aEvt) {
							if(req.readyState == 4) {
								if(req.status == 200){
									var res = req.responseText;
									if(res.search(/加入が必要です/) != -1){//未課金時
										failed_list.push(num);
										readNext();
									}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
										failed_list.push(num);
										readNext();
									}else if(res.search(/マイページ/) != -1){//ログイン時
										var res = req.responseText.split(">");
										var tmp = "data_another.html";
										var line = matchWordLine(res, tmp);
										if(line != -1){
											rival_list[num].hash = res[line].split("\"")[1].split("=")[1];
											rival_list[num].djname = trim(res[line+1].split("<")[0]);
											rival_list[num].iidxid = trim(res[line+4].split("<")[0]);
											rival_list[num].danisp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[0]));
											rival_list[num].danidp = daniStrToNum(trim(res[line+6].split("<")[0].split("/")[1]));
											rival_list[num].area = trim(res[line+8].split("<")[0]);

											follow(num);
										}else{
											failed_list.push(num);
											readNext();
										}
									}else{
										failed_list.push(num);
										readNext();
									}
								}else{
									failed_list.push(num);
									readNext();
								}
							}
						};
						req.send("mode=1&iidxid=" + id);
					}
					//main
					var req = new XMLHttpRequest();
					req.open('GET', 'http://p.eagate.573.jp/game/2dx/22/p/rival/rival_search.html', true);
					req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
					req.onreadystatechange = function (aEvt) {
						if(req.readyState == 4) {
							if(req.status == 200){
								var res = req.responseText;
								if(res.search(/加入が必要です/) != -1){//未課金時
									viewList();
									alert('Follow Editor for beatmaniaIIDX 21 SPADAからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}else if(res.search(/e-AMUSEMENT GATEへログインいたします/) != -1){//非ログイン時
									viewList();
									alert('Follow Editor for beatmaniaIIDX 21 SPADAからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}else if(res.search(/マイページ/) != -1){//ログイン時
									readNext();
								}else{
									viewList();
									alert('Follow Editor for beatmaniaIIDX 21 SPADAからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
								}
							}else{
								viewList();
								alert('Follow Editor for beatmaniaIIDX 21 SPADAからの引継ぎが完了しました。\n\n公式サイトに接続できなかったため、フォロー状態は引き継げませんでした。\n必要な場合はもう一度引き継ぎを行ってください。');
							}
						}
					};
					req.send(null);
				}else{
					viewList();
					alert('Follow Editor for beatmaniaIIDX 21 SPADAからの引継ぎが完了しました。');
				}
			}
		}catch(e){
			viewList();
//			alert('Follow Editor for beatmaniaIIDX 21 SPADAのデータがないか、データが壊れています。');
			alert(e + '\n\nFollow Editor for beatmaniaIIDX 21 SPADAのデータがないか、データが壊れています。');
		}
	}
}

viewSource = function(num){
	var req = new XMLHttpRequest();
	var URL = "";
	if(num==0){
		URL = "http://p.eagate.573.jp/game/2dx/22/p/rival/rival_follow.html";
	}else if(num==1){
		URL = "http://p.eagate.573.jp/game/2dx/22/p/rival/rival_follower.html";
	}else if(num==2){
		URL = "http://p.eagate.573.jp/game/2dx/22/p/rival/rival_list.html";
	}else if(num==3){
		URL = "http://p.eagate.573.jp/game/2dx/22/p/rival/rival2.html";
	}else if(num==4){
		URL = "http://p.eagate.573.jp/game/2dx/22/p/djdata/data_another.html?rival=" + rival_list[0].hash;
	}
	req.open('GET', URL, true);
	req.onreadystatechange = function (aEvt){
		if(req.readyState == 4){
			if(req.status == 200){
				try{
					var res = req.responseText.split(">");
					var txt = "<xmp>";
					for(var i=0; i<res.length; i++){
						txt += i + "\t" + res[i] + "\n";
					}
					txt += "</xmp>";
					mainTab.contentDocument.getElementById('data').innerHTML = txt;
				}catch(e){
					alert(e);
				}
			}
		}
	};
	req.send(null);

	return;
}

}
